
#ifndef TREEVIEW_LIB_H
#define TREEVIEW_LIB_H
void config_treeview(void);

void 
treeview_open_with(		widgets_t *widgets_p,record_entry_t *en);

const gchar *
treeview_get_selected_chdir (void);

void 
count_selection(		GtkTreeModel * treemodel, 
				GtkTreePath * treepath, 
				GtkTreeIter * iter, 
				gpointer data);
gboolean 
get_selectpath_iter(		GtkTreeIter * iter, 
				record_entry_t ** en);
gint 
get_tree_id(			GtkTreeView *treeview);

treestuff_t *
get_treestuff(			GtkTreeView *treeview);


gboolean 
local_branch_is_visible(	GtkTreeModel *treemodel);

treestuff_t *
get_only_visible_treestuff(	void);

GtkTreeView *
get_bigger_treeview(		void);

gint 
get_active_tree_id(		void);

void fireup_treeview(void);
/* gtk callbacks */
void
hide_branch_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

/* monitor */
gboolean update_dir(GtkTreeView * treeview, GtkTreeRowReference * reference);

void remove_it(GtkTreeView * treeview, GtkTreeRowReference * reference);
gint local_monitor(gboolean force);

/* row */
void 
update_icon(			GtkTreeModel * model, 
				GtkTreeIter * iterator);
gboolean 
remove_row(	GtkTreeModel *treemodel,
		GtkTreeIter *iter,
		GtkTreeRowReference *reference,
		record_entry_t *en);
void 
update_iconcolumn_for_row(	GtkTreeModel *treemodel, 
				GtkTreeIter *iter, 
				GdkPixbuf *Icon);
void 
insert_dummy_row(	GtkTreeModel *treemodel, 
			GtkTreeIter *parent_iter,
			GtkTreeRowReference *parent_reference,
			record_entry_t *parent_en,
			gchar *icon_id, 
			gchar *text);
gboolean 
prune_row(	GtkTreeModel *treemodel,
		GtkTreeIter *iter,
		GtkTreeRowReference *reference,
		record_entry_t *en);
void 
update_text_cell_for_row(	int cell_id,
				GtkTreeModel *treemodel, 
				GtkTreeIter *iter, 
				const gchar *tag);
gboolean 
update_row(		GtkTreeModel * treemodel, 
		        GtkTreeIter * iter, 
			GtkTreeRowReference *reference,
			record_entry_t * en);
void 
set_icon (			GtkTreeModel *treemodel, 
				GtkTreeIter * iterator);
void 
erase_dummy_row(	GtkTreeModel *treemodel, 
			GtkTreeIter *parent_iter,
			GtkTreeRowReference *parent_reference);
gboolean 
add_row(		GtkTreeModel *treemodel, 
			GtkTreeIter *parent_iter, 
			GtkTreeRowReference *parent_reference,
			GtkTreeIter *child_iter, 
			record_entry_t * child_en, 
			gchar *child_name);
void 
reset_dummy_row(	GtkTreeModel *treemodel, 
			GtkTreeIter *parent_iter,
			GtkTreeRowReference *parent_reference,
			record_entry_t *parent_en,
			gchar *icon_id, 
			gchar *text);

void 
add_contents_row(	GtkTreeModel *treemodel, 
			GtkTreeIter * iter, 
			xfdir_t * xfdir);

/*   entry */


/* widgets */
void 
turn_on_pasteboard(void);

void 
turn_on(void);

gboolean 
set_load_wait(void);

gboolean 
unset_load_wait(void);

void 
hide_bars(void);



/*  */
void set_treeview_title (GtkWidget *widget, gchar *path);

gboolean 
find_module_root(GtkTreeView * treeview,GtkTreeIter *iter,  record_entry_t ** en, const gchar *module_name);


void create_module_root_element(GtkTreeView * treeview, GtkTreeIter *iterator,
		const gchar *module_name);

void create_root_element(GtkTreeView * treeview,  GtkTreeIter *iterator,
		const gchar *which,const gchar *home);


GtkTreeView *init_xffm_treeviews(void);

int find_module_root(		GtkTreeView * treeview, 
				GtkTreeIter * iter, 
				record_entry_t ** en, 
				const gchar *which);

int get_module_root(		GtkTreeView * treeview, 
				GtkTreeIter * iter, 
				record_entry_t ** en, 
				const gchar *which);

gint 
set_relative_tree_id_from_model(	GtkTreeModel *treemodel);

GtkTreeIter *
get_iter_from_reference(	GtkTreeModel * treemodel, 
				GtkTreeRowReference *reference);

void 
on_treeview_column_click(	GtkTreeViewColumn * column, 
				gpointer data);
 
void 
set_font(			GtkTreeModel *treemodel,  
				GtkTreeIter * iterator);

void 
get_xffm_config(void);

#endif
